% =========================================================================
%> @file  PrepResultData.m
%> @author		Christian Campestrini (c.campestrini@tum.de)
%> @brief		Converts the estimation and reference data to the required 
%>              form. This is an individual function.
%>
%> @date		08.06.2016
%>
%> @param		none
%>
%> @retval		FilterResult (converted data struct)
%>
%> @syntax		FilterResult=PrepResultData();
% =========================================================================
function Result=PrepResultData()
%% CHANGE HERE
    % Load example data
    load('Example\FilterData.mat');
    load('Example\RawData.mat');
    % Here the result data is transformed to the required data format.
    % Change this for your data
    FNrAlgo=fieldnames(FilterData);
    % Loop for all algorithms
    for iAlgo=1:length(FNrAlgo)   

        FNrTest=fieldnames(FilterData.(FNrAlgo{iAlgo}));
        % Loop for all Tests
        for iTest=1:length(FNrTest)

            FNrTemp=fieldnames(FilterData.(FNrAlgo{iAlgo}).(FNrTest{iTest}));
            % Loop for a Temperatures
            for iTemp=1:length(FNrTemp)

                FNrProfile=fieldnames(FilterData.(FNrAlgo{iAlgo}).(FNrTest{iTest}).(FNrTemp{iTemp}));
                % Loop for all Profiles
                for iProfile=1:length(FNrProfile)
                    % Filter Data
                    Result.(FNrAlgo{iAlgo}).(FNrTest{iTest}).(FNrTemp{iTemp}).(FNrProfile{iProfile}).RefSOC=FilterData.(FNrAlgo{iAlgo}).(FNrTest{iTest}).(FNrTemp{iTemp}).(FNrProfile{iProfile}).CurrentCounter.BST;
                    Result.(FNrAlgo{iAlgo}).(FNrTest{iTest}).(FNrTemp{iTemp}).(FNrProfile{iProfile}).RefSOCBMS=FilterData.(FNrAlgo{iAlgo}).(FNrTest{iTest}).(FNrTemp{iTemp}).(FNrProfile{iProfile}).CurrentCounter.BMS;                
                    Result.(FNrAlgo{iAlgo}).(FNrTest{iTest}).(FNrTemp{iTemp}).(FNrProfile{iProfile}).EstSOC=FilterData.(FNrAlgo{iAlgo}).(FNrTest{iTest}).(FNrTemp{iTemp}).(FNrProfile{iProfile}).State.SOC;
                    Result.(FNrAlgo{iAlgo}).(FNrTest{iTest}).(FNrTemp{iTemp}).(FNrProfile{iProfile}).EstTime=FilterData.(FNrAlgo{iAlgo}).(FNrTest{iTest}).(FNrTemp{iTemp}).(FNrProfile{iProfile}).SimTime;
                    Result.(FNrAlgo{iAlgo}).(FNrTest{iTest}).(FNrTemp{iTemp}).(FNrProfile{iProfile}).RefTime=FilterData.(FNrAlgo{iAlgo}).(FNrTest{iTest}).(FNrTemp{iTemp}).(FNrProfile{iProfile}).SimTime;
                    
                    % Reference Data: Residual charge SOC 
                    Result.(FNrAlgo{iAlgo}).(FNrTest{iTest}).(FNrTemp{iTemp}).(FNrProfile{iProfile}).ResChSOC=RawData.(FNrTemp{iTemp}).(FNrProfile{iProfile}).REF.EndSOC;

                end
            end
        end
    end
end