% =========================================================================
%> @file  TabScore.m
%> @author		Christian Campestrini (c.campestrini@tum.de)
%> @brief		Creates and saves benchmark tables
%>
%> @date		08.06.2016
%>
%> @param		Data 
%> @param		Fail
%> @param		Temp
%> @param		Algo
%> @param		Path
%>
%> @retval		none
%>
%> @syntax		fitresult=TabScore(Time, SOC)
% =========================================================================
function TabScore(Data,Fail,Temp,Algo,Path)
    
    input.Name=inputname(1);
    input.Name=input.Name(1:3);
    input.Path=Path;
    
    
    input.tableColLabels1 = {'A';' ';'B';' ';'C';' '};
    input.tableColLabels2 = {['K_' input.Name];['K_' input.Name ',fail'];['K_' input.Name];['K_' input.Name ',fail'];['K_' input.Name];['K_' input.Name ',fail']};
    input.tableRowLabels  = {'' '' '-10 C','0 C','10 C','25 C','40 C','Ktemp'};
    
    if strcmp(input.Name,'Tra')
        Test='InitFail';
    else
        Test='InitOk';
    end
    
    if isfield(input,'Data')
        input=rmfield(input,'Data');
    end
    input.Data(1,:)=[Data.(Algo).(Test).A.Score Temp.(Algo).A.(input.Name)];        
    input.Data(3,:)=[Data.(Algo).(Test).B.Score Temp.(Algo).B.(input.Name)];

    if ~strcmp(input.Name,'Tra')
        input.Data(5,:)=[Data.(Algo).(Test).C.Score(end) NaN NaN NaN NaN NaN];

        input.Data(2,:)=[Fail.(Algo).A.(input.Name) NaN];
        input.Data(4,:)=[Fail.(Algo).B.(input.Name) NaN];
        input.Data(6,:)=[Fail.(Algo).C.(input.Name)(end) NaN NaN NaN NaN NaN];       
    else
        input.Data(5,:)=[Data.(Algo).(Test).A2.Score Temp.(Algo).A2.(input.Name)];            
        input.Data(6,:)=[0 0 0 0 0 0];            
    end

    input.Data=round(input.Data*10)/10;

    input.Algo={Algo,'','','','','','',''};

    input.Data=[input.tableColLabels1 input.tableColLabels2 num2cell(input.Data)];

    input.Data=[input.Algo; input.tableRowLabels; input.Data];
    try
        xlswrite([input.Path '\Tab' input.Name '_' Algo '.xlsx'],input.Data)    
    end
end